//Pizza.cs

//audio
datablock AudioProfile(EatSound)
{
   filename    = "./Eat.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(PizzaHealParticle)
{
   dragCoefficient      = 5.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   useInvAlpha          = false;
   textureName          = "./heal";
   colors[0]     = "1.0 1.0 1.0 1";
   colors[1]     = "1.0 1.0 1.0 1";
   colors[2]     = "0.0 0.0 0.0 0";
   sizes[0]      = 0.4;
   sizes[1]      = 0.6;
   sizes[2]      = 0.4;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(PizzaHealEmitter)
{
   ejectionPeriodMS = 35;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   ejectionOffset   = 1.0;
   velocityVariance = 0.49;
   thetaMin         = 0;
   thetaMax         = 120;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PizzaHealParticle";

   uiName = "Emote - Heal";
};

datablock ShapeBaseImageData(PizzaHealImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = $HeadSlot;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 3.00;
	stateEmitter[1]					= PizzaHealEmitter;
	stateEmitterTime[1]				= 0.350;
	stateSound[1]					= EatSound;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};
function PizzaHealImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

datablock ItemData(PizzaItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Pizza.dts";
	rotate = false;
	mass = 2;
	density = 0.4;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "E-B Pizza";
	iconName = "./Icon_Pizza";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = PizzaImage;
	canDrop = true;
};

datablock ShapeBaseImageData(PizzaImage)
{
   // Basic Item properties
   shapeFile = "./Pizza.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0.05 0.2 0";
   eyeOffset = 0; //"0.7 1.2 -0.25";
   rotation = eulerToMatrix( "-90 -90 0" );

   className = "WeaponImage";
   item = PizzaItem;

   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Initial start up state
	stateName[0]                     = "Ready";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]         = true;

	stateName[1]                     = "Fire";
	stateTransitionOnTimeout[1]      = "Ready";
	stateAllowImageChange[1]         = true;
      stateScript[1]                   = "onFire";
	stateTimeoutValue[1]		   = 1;
	stateSound[1]			= EatSound;
};

function PizzaImage::onFire(%this,%obj,%slot)
{
	

	for(%i=0;%i<5;%i++)
	{
		%toolDB = %obj.tool[%i];
		if(%toolDB $= %this.item.getID())
		{
                 if (%obj.client.hunger + 10 <= 100) {
                %obj.client.hunger = %obj.client.hunger + 10;
            messageClient(%obj.client, '', "\c6You have \c3" @ %obj.client.hunger @ "\c6 hunger.");

			//%obj.addHealth(75);
			%obj.emote(PizzaHealImage);
			%obj.tool[%i] = 0;
			%obj.weaponCount--;
			messageClient(%obj.client,'MsgItemPickup','',%i,0);
			serverCmdUnUseTool(%obj.client);
			break;
                     } else
    %obj.client.centerprint("You are not hungry enough to Eat this.");
		}
	}
}

package PizzaPackage
{
   function Armor::onCollision(%this, %obj, %col, %thing, %other)
   {
      if(%col.dataBlock $= "PizzaItem" && %col.pickupNow !$= 1)
      {
         if(!isObject(%col.spawnbrick))   
         {
            if((%obj.getDamageLevel() >= 1))
            {
               %obj.setDamageLevel(0);
               %obj.emote(PizzaHealImage);
               %col.delete();
            }
            else
               %col.pickupNow = 1;
            return;
         }
      }
      Parent::onCollision(%this, %obj, %col, %thing, %others);
   }
};
activatePackage(PizzaPackage);